
Redmine - Defect #38055

Inconsistent results for filtering issues containing custom fields

2022-12-17 07:16 - Ko Nagase

Status: Confirmed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Filters Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:  Affected version: 5.0.3

Description

How to reproduce

1. Prepare a working environment

$ RAILS_ENV=development bin/rails db:fixtures:load

2. Start Redmine and display http://localhost:3000/issues without login.

3. From filters, check off "Status" then add "Tracker" filter with operator "is" and value "Bug" and "Support request" (Because

"Searchable field" custom field is only available in those trackers).

=>The result is 8 issues.

4. Select "Searchable field" from "Add filter", select operator "contains" and value 125.

=>The result is 2 issues.

5. Change the operator to "doesn't contain" and apply it.

=>The result is 1 issues.

The total number of cases in No.4 and No.5 is 3 which does not match the total number of issues (6)

Expected behavior

The sum of the results of "contains" and "doesn't contain" matches the total number of issues.

If the condition is "is" and "is not", the sum of the results matches the total number of issues.

Possible Causes

The filter ignore issues which the custom field "Searchable filter" is not present when the filter is "doesn't contain".

Solution patch

To make the behavior consistent with "is" and "is not", the "doesn't contain" result should include the number of issues that do not

have the custom field.

We (Tomoko  Shimizu, Takashi Kato, Mizuki ISHIKAWA and Ko Nagase) created the attachment patch file which solves this issue by

modifying "not contains" operator SQL only when searching custom field values, so reviewing this is helpful.

Thanks,

History

#1 - 2022-12-17 08:54 - Ko Nagase

- File 2022-12-17-issue-filter.patch added

Sorry, I missed to attache the patch, so I upload it in this post.

#2 - 2022-12-18 09:24 - Go MAEDA

- Status changed from New to Confirmed

#3 - 2022-12-18 09:25 - Go MAEDA
http://localhost:3000/issues
https://www.redmine.org/users/305899
https://www.redmine.org/users/486714
https://www.redmine.org/users/259873
https://www.redmine.org/users/388654


- Target version set to Candidate for next major release

Files

2022-12-17-issue-filter.patch 1.69 KB 2022-12-17 Ko Nagase
